const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    delete: _delete
};

/**
 * Format an array of drugClassifications by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} drugClassifications - The array of drugClassifications to format.
 * @returns {Promise<Object[]>} - The formatted array of drugClassifications.
 */
const formatWithModifier = async (drugClassifications) => {
    return Promise.all(
        drugClassifications.map(async (drugClassification) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: drugClassification.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...drugClassification,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Retrieves all drugClassifications with their parent drugClassification title.
 * @param {Object} params - The query parameters.
 * @param {number[]} params.drugClassificationsId - The ids of the drugClassifications to retrieve.
 * @returns {Promise<Object>} - The response object with the drugClassifications and success status.
 */
async function getAll(params) {
    try {
        // filters
        const filterConditions = {};

        let drugClassifications = []
        drugClassifications = await dbSAPPS.DrugClassification.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
        });

        drugClassifications = drugClassifications.map(drugClassification => {
            return {
                ...drugClassification.dataValues
            }
        });

        drugClassifications = await formatWithModifier(drugClassifications);

        return {
            drugClassifications,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Get drugClassification items with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the drugClassification items.
 * @param {boolean|string} params.is_parent - A boolean or string indicating whether the drugClassification items should be parents or not.
 * @returns {Promise<Object>} Resolves with an object that contains the drugClassification items and a success flag.
 * @example
 * const result = await option({ is_parent: true });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        let options = [];
        options = await dbSAPPS.DrugClassification.findAll({
            attributes: ['id', 'name', 'display_name'],
            where: filterConditions,
            order: [['name', 'ASC']]
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active drugClassification items
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */

async function count(params) {
    try {
        // filter
        const filterConditions = {};

        const count = await dbSAPPS.DrugClassification.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new drugClassification item.
 * 
 * @param {Object} params - The new drugClassification item data.
 * @param {string} params.name - The name of the drugClassification item.
 * @param {string} params.title - The title of the drugClassification item.
 * @param {number} [params.parent_id] - The ID of the parent drugClassification item.
 * @param {string} [params.url] - The URL of the drugClassification item.
 * @param {string} [params.icon] - The icon of the drugClassification item.
 * @param {string} [params.type=link] - The type of the drugClassification item (link, group, collapse, separator).
 * @param {boolean} [params.enabled=true] - Whether the drugClassification item is enabled.
 * @param {number} [params.creation=Date.now()] - The creation timestamp of the drugClassification item.
 * @param {number} [params.modified=Date.now()] - The last modification timestamp of the drugClassification item.
 * @param {number} [params.owner=1] - The ID of the user who created the drugClassification item.
 * @param {number} [params.modified_by=1] - The ID of the user who last modified the drugClassification item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the drugClassification item creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingDisplayName = await dbSAPPS.DrugClassification.findOne({
            where: { display_name: params.display_name },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.DrugClassification.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing drugClassification item.
 * 
 * @param {number} id - The ID of the drugClassification item to update.
 * @param {Object} params - The updated drugClassification item data.
 * @param {string} [params.name] - The new name of the drugClassification item.
 * @param {string} [params.title] - The new title of the drugClassification item.
 * @param {number} [params.parent_id] - The new parent ID of the drugClassification item.
 * @param {string} [params.url] - The new URL of the drugClassification item.
 * @param {string} [params.icon] - The new icon of the drugClassification item.
 * @param {string} [params.type] - The new type of the drugClassification item (link, group, collapse, separator).
 * @param {boolean} [params.enabled] - Whether the drugClassification item is enabled or not.
 * @param {number} [params.creation] - The new creation timestamp of the drugClassification item.
 * @param {number} [params.modified] - The new last modification timestamp of the drugClassification item.
 * @param {number} [params.owner] - The new ID of the user who created the drugClassification item.
 * @param {number} [params.modified_by] - The new ID of the user who last modified the drugClassification item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the drugClassification item update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const drugClassification = await dbSAPPS.DrugClassification.findByPk(id);
        if (!drugClassification) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingDisplayName = await dbSAPPS.DrugClassification.findOne({
            where: {
                display_name: params.display_name,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await drugClassification.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a drugClassification
 * @param {number} id - the id of the drugClassification
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const drugClassification = await dbSAPPS.DrugClassification.findByPk(id);
        if (!drugClassification) return { success: false, message: 'ID not found!' };

        // delete
        await drugClassification.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
